<template as="div">
    <div class="flex justify-between items-center mt-5">
        <h2 class="font-mm font-bold text-primary">
            <fa-icon class="mr-1" icon="fa-file-contract" />
            Balancesheet
        </h2>
        <div v-if="!isReadOnly">
            <el-button :disabled="hasInvalid()" v-if="haveItemEdit > 0" @click="onSaveAll()"
                class="bg-primary hover:bg-primary-80 rounded-full" size="default" color="#025471">
                Save All({{ haveItemEdit }})
            </el-button>

            <el-button @click="addRow()" class="bg-green-600 hover:bg-green-700 rounded-full" size="default"
                color="#16a34a">
                Add
            </el-button>
        </div>
    </div>
    <div class="overflow-x-auto relative mt-4 cus">
        <table class=" text-sm text-left text-gray-500  w-full">
            <tbody class=" text-primary uppercase ">
                <tr>
                    <th scope="col" class="py-3 px-2 w-10 text-center">
                        No.
                    </th>
                    <th scope="col" class="py-3 px-2 w-52 text-center">
                        House Number
                    </th>
                    <th scope="col" class="py-3 px-2 w-52 text-center">
                        Claim Time
                    </th>
                    <th scope="col" class=" px-2 text-center">
                        Claim Percentage
                    </th>
                    <th scope="col" class=" px-2 text-center">
                        Claim Amount
                    </th>
                    <th scope="col" class="py-3 px-2 w-20 text-center">
                        Done
                    </th>
                    <th v-if="!isReadonly" scope="col" class="py-3 w-32 px-2 text-center">
                        Action
                    </th>
                </tr>
            </tbody>
            <template v-if="subtermList.length > 0">
                <Form as="tbody" v-slot="{ handleSubmit, meta }" v-for="(row, j) in subtermList" :key="j">
                    <tr>
                        <th scope="row" class="p-2 font-medium text-gray-900 whitespace-nowrap text-center">
                            {{ j + 1 }}
                        </th>
                        <th scope="row" class="p-2 font-medium text-gray-900 whitespace-nowrap text-center">
                            <Field v-if="row?.allowEdit" v-slot="{ value, errorMessage, handleChange }" rules="required"
                                name="nameKh" v-model="row.houseId" class="rounded-none mt-2">
                                <el-form-item :error="errorMessage">
                                    <el-select filterable :model-value="value" @update:model-value="handleChange"
                                        class="m-2" placeholder="Select a house" size="large">
                                        <el-option v-for="item in housesItems" :key="item.houseId"
                                            :label="`${item.house_number}`" :value="item.houseId" />
                                    </el-select>
                                </el-form-item>
                            </Field>
                            <span v-else>{{ row.nameKh }}</span>
                        </th>
                        <th scope="row" class="p-2 font-medium text-gray-900 whitespace-nowrap text-center">
                            <Field v-if="row?.allowEdit" v-slot="{ value, errorMessage, handleChange }" rules="required"
                                name="claimTime" v-model="row.claimTime" class="rounded-none mt-2">
                                <el-form-item :error="errorMessage">
                                    <el-input :validate-event="false" type="number" :model-value="value"
                                        @update:model-value="handleChange" placeholder="Claim Time" />
                                </el-form-item>
                            </Field>

                            <span v-else>{{ row.claimTime }}</span>
                        </th>
                        <th scope="row" class="p-2 font-medium text-gray-900 whitespace-nowrap text-center">
                            <Field v-if="row?.allowEdit" v-slot="{ value, errorMessage, handleChange }" rules="required"
                                name="claimPercentage" v-model="row.claimPercentage" class="rounded-none mt-2">
                                <el-form-item :error="errorMessage">
                                    <el-input :validate-event="false" type="number" :model-value="value"
                                        @update:model-value="handleChange" placeholder="Claim Percentage" />
                                </el-form-item>
                            </Field>
                            <span v-else>{{ row.claimPercentage }}</span>
                        </th>
                        <th scope="row" class="p-2 font-medium text-gray-900 whitespace-nowrap text-center">
                            <Field v-if="row?.allowEdit" v-slot="{ value, errorMessage, handleChange }" rules="required"
                                name="claimAmount" v-model="row.claimAmount" class="rounded-none mt-2">
                                <el-form-item :error="errorMessage">
                                    <el-input :validate-event="false" type="number" :model-value="value"
                                        @update:model-value="handleChange" placeholder="Claim Amount" />
                                </el-form-item>
                            </Field>
                            <span v-else v-html="(row.claimAmount)"></span>
                        </th>
                        <th scope="row"
                            class="p-2 font-medium text-gray-900 whitespace-nowrap text-center justify-center">
                            <Field v-slot="{ value, errorMessage, handleChange }" name="isDone" v-model="row.isDone"
                                class="rounded-none mt-2">
                                <el-form-item :error="errorMessage">
                                    <el-checkbox :validate-event="false" @change="onSaveOne(row, meta, j)"
                                        :model-value="value" @update:model-value="handleChange"></el-checkbox>
                                </el-form-item>
                            </Field>

                        </th>
                        <th scope="row" class="p-2 font-medium text-gray-900 whitespace-nowrap text-center">
                            <div v-if="row.allowEdit" class="flex space-x-2 justify-center">
                                <el-button @click="handleSubmit($event, onSaveOne(row, meta, j))"
                                    class="    bg-blue-700   hover:bg-blue-600    rounded-full     ml-2   px-3    py-4  "
                                    size="default" color="#1d4ed8"><fas-icon icon=" fa-save" />
                                </el-button>
                                <el-button @click="onCancel(j, row)"
                                    class="    bg-orange-300    hover:bg-orange-200    rounded-full    ml-2    px-3   py-4  "
                                    size="default" color="#fdba74">
                                    <fas-icon icon="fa-solid fa-cancel" />
                                </el-button>
                            </div>
                            <div v-else class="flex space-x-2 justify-center">
                                <el-button @click="onEdit(row)" type="button"
                                    class="text-white bg-yellow-600 hover:bg-yellow-700 focus:outline-none focus:ring-4 focus:ring-red-300 font-medium rounded-full text-sm px-3 py-2 text-center ">
                                    <fas-icon icon="fa-solid fa-pen-to-square" />
                                </el-button>
                                <el-button @click="onDelete(row?.id)" type="button"
                                    class="text-white bg-red-700 hover:bg-red-800 focus:outline-none focus:ring-4 focus:ring-red-300 font-medium rounded-full text-sm px-3 py-2 text-center ">
                                    <fas-icon icon="fa-solid fa-trash-can" />
                                </el-button>
                            </div>
                        </th>
                    </tr>
                </Form>
            </template>
            <tbody v-else>
                <tr class="bg-white ">
                    <th scope="row" colspan="100%"
                        class="py-3 px-6 font-medium text-center text-gray-900 whitespace-nowrap">
                        No Data
                    </th>
                </tr>
            </tbody>
        </table>
    </div>

</template>

<script>

import { delay} from '@/helpers';

import { computed, ref } from 'vue';
import { mapMutations, useStore } from 'vuex';
import { Form, Field } from 'vee-validate';

export default {
    name: 'VCollateralIfoSubTerm',
    components: {
        Form, Field
    },
    props: {
        data: {
            type: Object,
            default: () => ({})
        }
    },
    created() {
        this.fetchAll();
    },
    methods: {
        ...mapMutations({
            setSuggest: "MortgetAgreement/SET_MoRTGETAGREEMENT",
            removeSuggest: "MortgetAgreement/SET_MoRTGETAGREEMENT"
        }),
        onEdit(row) {
            this.suggests.find(o => o.id == row.id);
            row.allowEdit = true;
        },
        onCancel(index, row) {
            if (!row.id) {
                this.removeSuggest(index);
                return;
            }

            row.allowEdit = false;
        },
        addRow() {
            const newList = [
                ...this.subtermList,
                ...[{
                    allowEdit: true,
                    vendorPhysicalCheckSubId: '',
                    houseId: '',
                    claimTime: '',
                    claimPercentage: '',
                    claimAmount: 0,
                }],
            ];

            this.setSuggest(newList);
        }
    },
    setup(props) {
        const store = useStore();
        const showModal = ref(false);
        // const subForm = ref();
        const loading = ref(false);
        const loadingText = ref('');

        const fetchAll = () => {
            store.dispatch("VendorPhysicalCheckSub/fetchSuggest", props?.data?.id);
            store.dispatch("VendorSettlementSub/fetchPhysicalHouseList", props?.data?.settlementId);
        }
        const isSubLoading = computed(() => store.state['VendorPhysicalCheckSub'].isSubLoading);

        const housesItems = computed(() => (store.state["VendorSettlementSub"]?.housesPhysical || []));

        const subtermList = computed(() => store.state["MortgetAgreement"]?.items || []);
        const haveItemEdit = computed(() => {
            return (store.state["VendorPhysicalCheckSub"]?.suggest || []).filter(o => o.allowEdit).length;
        });

        const onSaveOne = async (values, meta, index) => {
            if (meta.valid) {
                values.vendorPhysicalCheckSubId = props?.data?.id;
                values.index = index;
                values.claimTime = values.claimTime + '';
                if (!values.id) {
                    await store.dispatch("VendorPhysicalCheckSub/addSuggest", values);
                } else {
                    await store.dispatch("VendorPhysicalCheckSub/updateSuggest", values);
                }
            }

        }

        const onDelete = async (id) => {
            await store.dispatch("VendorPhysicalCheckSub/deleteSuggest", id);
            await store.dispatch("VendorPhysicalCheckSub/fetchSuggest", props?.data?.id);
        }

        const isReadOnly = computed(() => {
            return props?.data?.recStatus > 0;
        });

        const suggests = computed(() => {
            return [
                ...(store.state["VendorPhysicalCheckSub"]?.suggest || [])
            ]
        });

        const onSaveAll = async () => {
            loading.value = true;
            let count = 0;
            loadingText.value = `${count} successful!`;
            for (let i in (subtermList.value || [])) {
                const data = subtermList.value[i];
                if (data.allowEdit) {
                    data.vendorPhysicalCheckSubId = props?.data?.id;
                    data.index = i;
                    data.claimTime = data.claimTime + '';
                    await delay(200);
                    if (!data.id) {
                        await store.dispatch("VendorPhysicalCheckSub/addSuggest", data);
                        count++;
                        loadingText.value = `${count} successful!`;
                    } else {
                        await store.dispatch("VendorPhysicalCheckSub/updateSuggest", data);
                    }
                }
            }
            loading.value = false;

        }

        

        return {
            isSubLoading,
            fetchAll,
            // subForm,
            onSaveOne,
            showModal,
            isReadOnly,
            subtermList,
            onDelete,
            suggests,
            haveItemEdit,
            onSaveAll,
            housesItems,
           
        }
    }

}

</script>
<style lang="scss" scoped>
table,
th,
td {
    border: 1px solid #ddd;
    border-collapse: collapse;
}

tbody:nth-child(odd) {
    background-color: #edeeef !important;
}
</style>